void Merger(int N, const char* outputDir, const char* outputFileName, const char* inputBaseName) {
    TString outputPath = Form("%s/%s.root", outputDir, outputFileName);
    TFileMerger merger;
    merger.OutputFile(outputPath, "RECREATE");  // Correct usage: specify the output file path directly

    for (int i = 0; i < N; i++) {
        TString fileName = Form("%s%d.root", inputBaseName, i); // Base name + index + .root
        TFile *inputFile = TFile::Open(fileName);
        if (!inputFile || inputFile->IsZombie()) {
            std::cerr << "Error opening file: " << fileName << std::endl;
            continue;
        }
        merger.AddFile(fileName);  // Add file to the merger
        cout << "Added file " << fileName << endl; 
        // Display progress
        int progress = ((i + 1) * 100) / N;
        std::cout << "\rMerging files: " << progress << "% complete." << std::flush;
    }

    // Perform the merge operation
    merger.Merge();

    std::cout << std::endl << "Merging completed! Output saved at: " << outputPath << std::endl;
}

