#!/bin/bash

max_jobs=20  # Set the maximum number of parallel jobs (cores)

for run in {201..260}; do
  while [ $(jobs -r | wc -l) -ge $max_jobs ]; do
    wait -n  # Wait for at least one job to finish
    echo "A job has finished. $(jobs -r | wc -l) jobs remaining."
  done
  root -b -q "convert.C($run)" &
  echo "Started job for run $run. $(jobs -r | wc -l) jobs currently running."
done

# Ensure all remaining jobs are completed
wait
echo "All jobs are complete."

