TRandom3 ra;

void CheckKinematics(){

  TFile* ofile = new TFile("kine.root","recreate");

  NPL::Reaction* r1 = new NPL::Reaction("7Li(p,1n)7Be@13.95");

  double beam_energy_init = r1->GetBeamEnergy();
  double eloss = 0.070;
  
  double beam_energy;
  double ThetaCM;
  double E3, Theta3, E4, Theta4;
  TTree* tree = new TTree("KineTree","KineTree");
  tree->Branch("beam_energy",&beam_energy,"beam_energy/D");
  tree->Branch("ThetaCM",&ThetaCM,"ThetaCM/D");
  tree->Branch("E3",&E3,"E3/D");
  tree->Branch("Theta3",&Theta3,"Theta3/D");
  tree->Branch("E4",&E4,"E4/D");
  tree->Branch("Theta4",&Theta4,"Theta4/D");


  for(int i=0; i<1e6; i++){
    beam_energy = ra.Uniform(beam_energy_init - eloss, beam_energy_init);

    ThetaCM = ra.Uniform(0,180);
    r1->SetThetaCM(ThetaCM*deg);
    r1->SetBeamEnergy(beam_energy);
    r1->KineRelativistic(Theta3,E3,Theta4,E4);

    Theta3 = Theta3/deg;
    Theta4 = Theta4/deg;
    
    tree->Fill();
  }

  tree->Write();

  ofile->Close();
}
