TRandom3 ra;
double density_7Li = 0.534; // g/cm3
///////////////////////////////////////////////////
void DirectKinematics(double thickness_mg_cm2 = 0.3){

  NPL::EnergyLoss* p7Li_loss;
  p7Li_loss = new NPL::EnergyLoss("../EnergyLossTable/proton_7Li.G4table","G4Table",100);

  TFile* ofile = new TFile("direct_kine.root","recreate");

  NPL::Reaction* r1 = new NPL::Reaction("p(7Li,1n)7Be@2.8");

  double thickness_micrometer;
  thickness_micrometer = thickness_mg_cm2/(density_7Li*1e3)*1e4;
  cout << thickness_mg_cm2 << " mg/cm2 -> " << thickness_micrometer << " um" << endl;

  double beam_energy_init = r1->GetBeamEnergy();
  double eloss;
  eloss = p7Li_loss->EnergyLossCalculation(beam_energy_init,thickness_micrometer*micrometer,0);

  cout << "Energy Loss = " << eloss << " MeV" << endl;

  double beam_energy;
  double ThetaCM;
  double E3, Theta3, E4, Theta4;
  TTree* tree = new TTree("KineTree","KineTree");
  tree->Branch("beam_energy",&beam_energy,"beam_energy/D");
  tree->Branch("ThetaCM",&ThetaCM,"ThetaCM/D");
  tree->Branch("E3",&E3,"E3/D");
  tree->Branch("Theta3",&Theta3,"Theta3/D");
  tree->Branch("E4",&E4,"E4/D");
  tree->Branch("Theta4",&Theta4,"Theta4/D");


  for(int i=0; i<1e6; i++){
    beam_energy = ra.Uniform(beam_energy_init - eloss, beam_energy_init);

    ThetaCM = ra.Uniform(0,180);
    r1->SetThetaCM(ThetaCM*deg);
    r1->SetBeamEnergy(beam_energy);
    r1->KineRelativistic(Theta3,E3,Theta4,E4);

    Theta3 = Theta3/deg;
    Theta4 = Theta4/deg;

    tree->Fill();
  }

  tree->Write();

  ofile->Close();
}
