TChain* chain;
TCutG* cut10Be[8];

/////////////////////////////////////////////////////////////////
void LoadCut(string part){
  string path = "../Mass/cut/"+ part + "/cut10Be.root";
  TFile* fcut = new TFile(path.c_str());
  for(int i=0; i<8; i++){
   cut10Be[i] = (TCutG*)fcut->Get(Form("cut10Be_det%i",i+1));
  }
}

/////////////////////////////////////////////////////////////////
void FillHistoCharge(string part="part1"){

  LoadCut(part);

  chain = new TChain("PhysicsTree");
  if(part=="part1"){
    //chain->Add("../../root/analysis/run_28.root");
    //chain->Add("../../root/analysis/run_29.root");
    //chain->Add("../../root/analysis/run_30.root");
    //chain->Add("../../root/analysis/run_32.root");
    //chain->Add("../../root/analysis/run_36.root");
    //chain->Add("../../root/analysis/run_37.root");
    //chain->Add("../../root/analysis/run_39.root");
    //chain->Add("../../root/analysis/run_41.root");
    //chain->Add("../../root/analysis/run_42.root");
    //chain->Add("../../root/analysis/run_43.root");
    //chain->Add("../../root/analysis/run_44.root");
    //chain->Add("../../root/analysis/run_45.root");
    //chain->Add("../../root/analysis/run_46.root");
    chain->Add("../../root/analysis/run_48.root");
    //chain->Add("../../root/analysis/run_49.root");
    //chain->Add("../../root/analysis/run_50.root");
    //chain->Add("../../root/analysis/run_51.root");
    //chain->Add("../../root/analysis/run_52.root");
    //chain->Add("../../root/analysis/run_53.root");
  }
  else if(part=="part2"){
    chain->Add("../../root/analysis/run_55.root");
    chain->Add("../../root/analysis/run_56.root");
    chain->Add("../../root/analysis/run_57.root");
    chain->Add("../../root/analysis/run_58.root");
    chain->Add("../../root/analysis/run_59.root");
    chain->Add("../../root/analysis/run_60.root");
    chain->Add("../../root/analysis/run_61.root");
    chain->Add("../../root/analysis/run_62.root");
    chain->Add("../../root/analysis/run_63.root");
    chain->Add("../../root/analysis/run_64.root");
    chain->Add("../../root/analysis/run_65.root");
    chain->Add("../../root/analysis/run_66.root");
    chain->Add("../../root/analysis/run_67.root");
    chain->Add("../../root/analysis/run_68.root");
    chain->Add("../../root/analysis/run_69.root");
  }
  double DeltaEcorr;
  double Elab;
  double Mass;
  double Ex240Pu;
  double VAMOS_TS_hour;
  int Telescope;
  int m_2alpha;
  int FPMW_Section;
  double FF_Z;

  chain->SetBranchStatus("DeltaEcorr","true");
  chain->SetBranchAddress("DeltaEcorr",&DeltaEcorr);
  chain->SetBranchStatus("Elab","true");
  chain->SetBranchAddress("Elab",&Elab);
  chain->SetBranchStatus("FF_Mass13","true");
  chain->SetBranchAddress("FF_Mass13",&Mass);
  chain->SetBranchStatus("Ex240Pu","true");
  chain->SetBranchAddress("Ex240Pu",&Ex240Pu);
  chain->SetBranchStatus("VAMOS_TS_hour","true");
  chain->SetBranchAddress("VAMOS_TS_hour",&VAMOS_TS_hour);
  chain->SetBranchStatus("Telescope","true");
  chain->SetBranchAddress("Telescope",&Telescope);
  chain->SetBranchStatus("m_2alpha","true");
  chain->SetBranchAddress("m_2alpha",&m_2alpha);
  chain->SetBranchStatus("FPMW_Section","true");
  chain->SetBranchAddress("FPMW_Section",&FPMW_Section);
  chain->SetBranchStatus("FF_Z","true");
  chain->SetBranchAddress("FF_Z",&FF_Z);



  TH1F *hcharge[11];
  for(int i=0; i<11; i++){
    TString histo_name = Form("hcharge_%iMeV",i+6);
    hcharge[i] = new TH1F(histo_name, histo_name,1000,20,80); 
  }
  TH1F* hChargeAll = new TH1F("hcharge_all","hcharge_all",1000,20,80);
  TH2D* hChargeVsEx = new TH2D("hcharge_vs_ex","hcharge_vs_ex",20,0,20,1000,20,80);

  int nentries = chain->GetEntries();
  cout << "**** Number of entries to be treated: " << nentries << " ****" << endl; 
  for(int i=0; i<nentries; i++){
    chain->GetEntry(i);
    if(i%100000==0){
      cout << "\033[34m\r Processing tree..." << (double)i/nentries*100 << "\% done" << flush;
    }

    if(VAMOS_TS_hour>0){

      hChargeAll->Fill(FF_Z);
      if(Telescope>0) {

        if(FPMW_Section>4 && cut10Be[Telescope-1]->IsInside(Elab,DeltaEcorr)){
          hChargeVsEx->Fill(Ex240Pu,FF_Z);
          if(Ex240Pu>5.5 && Ex240Pu<6.5) hcharge[0]->Fill(FF_Z);
          else if(Ex240Pu>6.5 && Ex240Pu<7.5) hcharge[1]->Fill(FF_Z);
          else if(Ex240Pu>7.5 && Ex240Pu<8.5) hcharge[2]->Fill(FF_Z);
          else if(Ex240Pu>8.5 && Ex240Pu<9.5) hcharge[3]->Fill(FF_Z);
          else if(Ex240Pu>9.5 && Ex240Pu<10.5) hcharge[4]->Fill(FF_Z);
          else if(Ex240Pu>10.5 && Ex240Pu<11.5) hcharge[5]->Fill(FF_Z);
          else if(Ex240Pu>11.5 && Ex240Pu<12.5) hcharge[6]->Fill(FF_Z);
          else if(Ex240Pu>12.5 && Ex240Pu<13.5) hcharge[7]->Fill(FF_Z);
          else if(Ex240Pu>13.5 && Ex240Pu<14.5) hcharge[8]->Fill(FF_Z);
          else if(Ex240Pu>14.5 && Ex240Pu<15.5) hcharge[9]->Fill(FF_Z);
          else if(Ex240Pu>15.5 && Ex240Pu<16.5) hcharge[10]->Fill(FF_Z);
        }
      }
    }
  }

  TString filename = Form("histo_charge_%s.root",part.c_str());
  TFile *ofile = new TFile(filename,"recreate");
  for(int i=0; i<11; i++){
    hcharge[i]->Write();
  }
  hChargeAll->Write();
  hChargeVsEx->Write();
  ofile->Close();



}
