# Linearisation of MWPC

This macro is made to generate the txt file necessary to linearise the MW of
VAMOS in NPTOOL.

## Step 1 : HistoPosFiller.cxx

First thing first you need a run filled with a good amount of data with the
position on the FPMW unlinearised. 

Then execute the HistoPosFiller.cxx macro with the following command in terminal
: root 'HistoPosFiller.cxx(RunStart,RunEnd)'

The run you are using should have a name of the form : linea_$RunNumber$.root

This macro will fill the histogram with the unlinearised FPMW position and store them in the HistUnlinea.root file. It is mandatory to run the following steps.

## Step 2 : LinearisationTxt.cxx

This macro will generate the txt file made to linearise the MWPC.
Every upgrade to the code should be made in this file, please try to keep track
of the version and store the previous one in the legacy code folder.

This macro doesn't take any argument and use the data generated in the previous
step as automatic input. It generate a Linearisation.txt file which hold the
config data made to linearise the MW.

A common error returned by this macro is "Error in <TAxis::Set>: bins must be in
increasing order" : this sould be avoided as much as possible and is influenced
heavily by the definition of the bound of the histogram and the rebinning of the
histogram to generate the TGraph.

## Step 3 : LinearisationTransfo.cxx
This macro is here to test the linearisation.txt file.
It simulate what is implemented in NPTOOL and should be used as a sanity check.

It apply the transfo event per event and draw a variable bin histogram that
should mimick the shape of the original histogram.

## Step 4 : Implement in project
execute the following line from the current path :

cp Linearisation.txt ../../config/.

and add a ConfigFPMW.dat file with the following structure :

ConfigFPMW
LINEA_PATH ./configs/Linearisation.txt
 
execute the analysis some LinPositionX and LinPositionY should be filled
